config/routes.rb
Rails.application.routes.draw do
  resources :comments
  resources :analyses
  resources :static_pages
  root 'static_pages#index'
  resources :consultations  do
    get "allindex", on: :collection
  end
  get 'micontroller/allindex'
  devise_for :patients do
  end
  get "/static_pages/index" => "static_pages#index"
  #PATIENT INFORMATION
  match '/patient', to: 'patients#show', via: 'get'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :patient
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :authenticate_patient!
  before_action :set_comment, only: [:show, :edit, :update, :destroy]

  # GET /comments
  # GET /comments.json
  def index
    @comments = current_patient.comments.order('created_at DESC')
  end

  # GET /comments/1
  # GET /comments/1.json
  def show
    respond_to do |format|
      format.html
      format.json
      format.pdf { render template: 'comments/pdfView', pdf: 'Comentario'}
    end
  end

  # GET /comments/new
  def new
    @comment = Comment.new
  end

  # GET /comments/1/edit
  def edit
  end

  # POST /comments
  # POST /comments.json
  def create
    @comment = Comment.new(comment_params)
    @comment.patient_id = current_patient.id
    respond_to do |format|
      if @comment.save
        format.html { redirect_to @comment, notice: 'Comentario creado con éxito.' }
        format.json { render :show, status: :created, location: @comment }
      else
        format.html { render :new }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /comments/1
  # PATCH/PUT /comments/1.json
  def update
    respond_to do |format|
      if @comment.update(comment_params)
        format.html { redirect_to @comment, notice: 'Comentario editado.' }
        format.json { render :show, status: :ok, location: @comment }
      else
        format.html { render :edit }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /comments/1
  # DELETE /comments/1.json
  def destroy
    @comment.destroy
    respond_to do |format|
      format.html { redirect_to static_pages_path, notice: 'Comentario eliminado con éxito.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_comment
      @comment = Comment.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def comment_params
      params.require(:comment).permit(:date, :reason, :comment, :patient_id)
    end
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/views/comments/_form.html.erb
<%= form_with(model: comment, local: true) do |form| %>
  <% if comment.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(comment.errors.count, "error") %> prohibited this comment from being saved:</h2>

      <ul>
      <% comment.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :date, 'Fecha' %>
    <%= form.date_select :date %>
  </div>

  <div class="field">
    <%= form.label :reason,'Asunto'%>
    <%= form.text_field :reason %>
  </div>

  <div class="field">
    <%= form.label :comment, 'Comentario' %>
    <%= form.text_area :comment %>
  </div>

  <div class="actions">
    <%= form.submit value = "Crear comentario"%>
  </div>
<% end %>

app/views/comments/edit.html.erb
<h1>Editar Comentario</h1>

<%= render 'form', comment: @comment %>

<%= link_to 'Mostrar', @comment %> |
<%= link_to 'Atrás', { controller: "static_pages" } %>

app/views/comments/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Comments</h1>

<table>
  <thead>
    <tr>
      <th>Date</th>
      <th>Reason</th>
      <th>Comment</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @comments.each do |comment| %>
      <tr>
        <td><%= comment.date %></td>
        <td><%= comment.reason %></td>
        <td><%= comment.comment %></td>
        <td><%= link_to 'Show', comment %></td>
        <td><%= link_to 'Edit', edit_comment_path(comment) %></td>
        <td><%= link_to 'Destroy', comment, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Comment', new_comment_path %>

app/views/comments/new.html.erb
<h1>Nuevo comentario</h1>

<%= render 'form', comment: @comment %>

<%= link_to 'Atrás', { controller: "static_pages" } %>

app/views/comments/pdfView.pdf.erb
<head>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<p>
  <strong>Fecha:</strong>
  <%= @comment.date %>
</p>
<p>
  <strong>Asunto:</strong>
  <%= @comment.reason %>
</p>
<p>
  <strong>Comentario:</strong>
  <%= @comment.comment %>
</p>

app/views/comments/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Fecha:</strong>
  <%= @comment.date %>
</p>

<p>
  <strong>Asunto:</strong>
  <%= @comment.reason %>
</p>

<p>
  <strong>Comentario:</strong>
  <%= @comment.comment %>
</p>

<%= link_to 'Generar documento', comment_url(format: :pdf) %> |
<%= link_to 'Editar', edit_comment_path(@comment) %> |
<%= link_to 'Atrás', { controller: "static_pages" } %>